Documentation: quote {non-attributes} for asciidoc
[git/dscho.git] / git-submodule.sh
blobc29e2c3c9dd0bf42cc6ac68f70aef1fc742c5207
1 #!/bin/sh
3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 USAGE='[--quiet] [--cached] [add <repo> [-b branch]|status|init|update] [--] [<path>...]'
8 . git-sh-setup
9 require_work_tree
11 add=
12 branch=
13 init=
14 update=
15 status=
16 quiet=
17 cached=
20 # print stuff on stdout unless -q was specified
22 say()
24 if test -z "$quiet"
25 then
26 echo "$@"
30 # NEEDSWORK: identical function exists in get_repo_base in clone.sh
31 get_repo_base() {
33 cd "`/bin/pwd`" &&
34 cd "$1" || cd "$1.git" &&
36 cd .git
37 pwd
39 ) 2>/dev/null
43 # Map submodule path to submodule name
45 # $1 = path
47 module_name()
49 name=$(GIT_CONFIG=.gitmodules git-config --get-regexp '^submodule\..*\.path$' "$1" |
50 sed -nre 's/^submodule\.(.+)\.path .+$/\1/p')
51 test -z "$name" &&
52 die "No submodule mapping found in .gitmodules for path '$path'"
53 echo "$name"
57 # Clone a submodule
59 # Prior to calling, modules_update checks that a possibly existing
60 # path is not a git repository.
61 # Likewise, module_add checks that path does not exist at all,
62 # since it is the location of a new submodule.
64 module_clone()
66 path=$1
67 url=$2
69 # If there already is a directory at the submodule path,
70 # expect it to be empty (since that is the default checkout
71 # action) and try to remove it.
72 # Note: if $path is a symlink to a directory the test will
73 # succeed but the rmdir will fail. We might want to fix this.
74 if test -d "$path"
75 then
76 rmdir "$path" 2>/dev/null ||
77 die "Directory '$path' exist, but is neither empty nor a git repository"
80 test -e "$path" &&
81 die "A file already exist at path '$path'"
83 git-clone -n "$url" "$path" ||
84 die "Clone of '$url' into submodule path '$path' failed"
88 # Add a new submodule to the working tree, .gitmodules and the index
90 # $@ = repo [path]
92 # optional branch is stored in global branch variable
94 module_add()
96 repo=$1
97 path=$2
99 if test -z "$repo"; then
100 usage
103 # Turn the source into an absolute path if
104 # it is local
105 if base=$(get_repo_base "$repo"); then
106 repo="$base"
109 # Guess path from repo if not specified or strip trailing slashes
110 if test -z "$path"; then
111 path=$(echo "$repo" | sed -e 's|/*$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
112 else
113 path=$(echo "$path" | sed -e 's|/*$||')
116 test -e "$path" &&
117 die "'$path' already exists"
119 git-ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
120 die "'$path' already exists in the index"
122 module_clone "$path" "$repo" || exit
123 (unset GIT_DIR && cd "$path" && git checkout -q ${branch:+-b "$branch" "origin/$branch"}) ||
124 die "Unable to checkout submodule '$path'"
125 git add "$path" ||
126 die "Failed to add submodule '$path'"
128 GIT_CONFIG=.gitmodules git config submodule."$path".path "$path" &&
129 GIT_CONFIG=.gitmodules git config submodule."$path".url "$repo" &&
130 git add .gitmodules ||
131 die "Failed to register submodule '$path'"
135 # Register submodules in .git/config
137 # $@ = requested paths (default to all)
139 modules_init()
141 git ls-files --stage -- "$@" | grep -e '^160000 ' |
142 while read mode sha1 stage path
144 # Skip already registered paths
145 name=$(module_name "$path") || exit
146 url=$(git-config submodule."$name".url)
147 test -z "$url" || continue
149 url=$(GIT_CONFIG=.gitmodules git-config submodule."$name".url)
150 test -z "$url" &&
151 die "No url found for submodule path '$path' in .gitmodules"
153 git-config submodule."$name".url "$url" ||
154 die "Failed to register url for submodule path '$path'"
156 say "Submodule '$name' ($url) registered for path '$path'"
157 done
161 # Update each submodule path to correct revision, using clone and checkout as needed
163 # $@ = requested paths (default to all)
165 modules_update()
167 git ls-files --stage -- "$@" | grep -e '^160000 ' |
168 while read mode sha1 stage path
170 name=$(module_name "$path") || exit
171 url=$(git-config submodule."$name".url)
172 if test -z "$url"
173 then
174 # Only mention uninitialized submodules when its
175 # path have been specified
176 test "$#" != "0" &&
177 say "Submodule path '$path' not initialized"
178 continue
181 if ! test -d "$path"/.git
182 then
183 module_clone "$path" "$url" || exit
184 subsha1=
185 else
186 subsha1=$(unset GIT_DIR && cd "$path" &&
187 git-rev-parse --verify HEAD) ||
188 die "Unable to find current revision in submodule path '$path'"
191 if test "$subsha1" != "$sha1"
192 then
193 (unset GIT_DIR && cd "$path" && git-fetch &&
194 git-checkout -q "$sha1") ||
195 die "Unable to checkout '$sha1' in submodule path '$path'"
197 say "Submodule path '$path': checked out '$sha1'"
199 done
202 set_name_rev () {
203 revname=$( (
204 unset GIT_DIR &&
205 cd "$1" && {
206 git-describe "$2" 2>/dev/null ||
207 git-describe --tags "$2" 2>/dev/null ||
208 git-describe --contains --tags "$2"
211 test -z "$revname" || revname=" ($revname)"
215 # List all submodules, prefixed with:
216 # - submodule not initialized
217 # + different revision checked out
219 # If --cached was specified the revision in the index will be printed
220 # instead of the currently checked out revision.
222 # $@ = requested paths (default to all)
224 modules_list()
226 git ls-files --stage -- "$@" | grep -e '^160000 ' |
227 while read mode sha1 stage path
229 name=$(module_name "$path") || exit
230 url=$(git-config submodule."$name".url)
231 if test -z "url" || ! test -d "$path"/.git
232 then
233 say "-$sha1 $path"
234 continue;
236 revname=$(unset GIT_DIR && cd "$path" && git-describe --tags $sha1)
237 set_name_rev "$path" $"sha1"
238 if git diff-files --quiet -- "$path"
239 then
240 say " $sha1 $path$revname"
241 else
242 if test -z "$cached"
243 then
244 sha1=$(unset GIT_DIR && cd "$path" && git-rev-parse --verify HEAD)
245 set_name_rev "$path" $"sha1"
247 say "+$sha1 $path$revname"
249 done
252 while case "$#" in 0) break ;; esac
254 case "$1" in
255 add)
256 add=1
258 init)
259 init=1
261 update)
262 update=1
264 status)
265 status=1
267 -q|--quiet)
268 quiet=1
270 -b|--branch)
271 case "$2" in
273 usage
275 esac
276 branch="$2"; shift
278 --cached)
279 cached=1
282 break
285 usage
288 break
290 esac
291 shift
292 done
294 case "$add,$branch" in
295 1,*)
300 usage
302 esac
304 case "$add,$init,$update,$status,$cached" in
305 1,,,,)
306 module_add "$@"
308 ,1,,,)
309 modules_init "$@"
311 ,,1,,)
312 modules_update "$@"
314 ,,,1,*)
315 modules_list "$@"
318 usage
320 esac